<template>
  <div v-if="promotions.length > 0" class="px-2 flex flex-col items-center">
    <div
      v-for="(promotion, index) in promotions"
      :key="index"
      class="mb-3 first:mt-3 flex flex-col overflow-hidden rounded-lg bg-background5 promo-card-border w-full playful-promotion-bar"
    >
      <div class="flex justify-center h-[146px] items-start overflow-hidden">
        <img
          v-lazy="promotion.ImagePathForDisplay"
          class="w-[372px] promotion-img"
          alt="Promotion"
        />
      </div>
      <div
        class="flex flex-col justify-center items-start pb-4 pt-2 px-3 w-full promotion-content"
      >
        <div class="flex flex-col justify-center items-start w-full pb-4">
          <span class="font-bold fc-text4">{{ promotion.Title }}</span>
          <p class="text-[12px] fc-primary">
            <span class="fc-text4">{{ $t("duration") }}</span> :
            {{ promotion.DateRangeForDisplay }}
          </p>
          <span class="text-[12px] fc-text4"
            >{{ $t("code") }} : {{ promotion.PromoCode }}</span
          >
        </div>
        <div
          class="flex flex-row items-start justify-center h-[40px] w-full gap-4 information-info"
        >
          <el-button
            class="info-button no-field-btn promotion-btn"
            :type="selectedTheme === 'black' ? 'secondary' : 'primary'"
            plain
            round
            @click="onMoreInformation(promotion)"
            :id = "`mobile_${ID.PROMOTION_INFO}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
            >{{
              themeColor.Text === "bk8" ? $t("more") : $t("information")
            }}</el-button>
          <template v-if="promotion.PromotionTypeId === 10">
            <el-button
              v-if="validateLuckyWheelbutton(promotion)"
              round
              type="primary"
              class="apply promotion-button promotion-btn"
              @click="onClickSpinNow"
              :id = "`mobile_${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >{{ $t("Spin Now") }}</el-button
            >
          </template>
          <template v-else>
            <el-button
              v-if="buttonApplyPromotionEnabled(promotion)"
              round
              type="primary"
              class="apply promotion-button promotion-btn"
              :loading="
                isProcessing &&
                applyRequest.PromotionId === promotion.Id &&
                !isDialogVisible
              "
              :disabled="isProcessing && !isDialogVisible"
              @click="onApplyPromotion(promotion)"
              :id = "`mobile_${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >{{ $t("apply") }}</el-button
            >
            <el-button
              v-else-if="!authenticated && !register.IsHidden"
              class="relative is-absolute apply promotion-button promotion-btn"
              type="primary"
              round
              :disabled="isProcessing && !isDialogVisible"
              @click="toggleAuthModal"
              :id = "`mobile_${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >{{ $t("apply") }}</el-button
            >
          </template>
        </div>
      </div>
    </div>
  </div>
  <div v-else class="flex flex-col justify-center items-center mt-[25px] no-promotion-section">
    <span class="font-bold text-lg fc-text">{{ $t("no_promotion_info") }}</span>
    <span class="font-bold text-lg fc-text">{{ assignHashText }}</span>
  </div>
  <el-dialog
    v-model="isDialogVisible"
    :show-close="false"
    custom-class="el-promo-dialog min-h-[318px] border border-solid border-[color:var(--border)]"
    destroy-on-close
    width="90%"
    :before-close="onCancel"
  >
    <template #title>
      <div class="promo-header-dialog">
        <span class="text-sm font-bold leading-4 fc-text4 mr-2">
          {{ promotionModel.Title }}
        </span>
        <div class="min-w-[20px] h-[20px]" @click="onCancel">
          <font-awesome-icon icon="circle-xmark" class="fc-text fa-lg" />
        </div>
      </div>
    </template>
    <div class="flex flex-col w-full">
      <el-scrollbar
        v-if="promotionModel.Content && promotionModel.Content.length > 0"
        :class="{ 'border-b-[1px]': isSBO }"
        max-height="calc(100vh - 175px)"
      >
      <div class="flex flex-col items-center justify-center">
        <img
          v-lazy="promotionModel.ImagePathForDisplay"
          class="w-full max-h-[146px] object-contain"
          alt="Promotion"
        />
      </div>
      <div class="flex flex-col justify-center items-start py-2 gap-1 p-5 pb-4">
        <div class="flex flex-row items-start p-0 gap-1">
          <p class="font-normal text-xs leading-[14px] fc-primary">
            <span class="fc-text4">{{ $t("duration") }}</span> :
            {{ promotionModel.DateRangeForDisplay }}
          </p>
        </div>
        <div class="flex flex-row items-start p-0 gap-1">
          <span class="font-normal text-xs leading-[14px] fc-text4">
            {{ $t("code") }} : {{ promotionModel.PromoCode }}
          </span>
        </div>
        <div class="pb-2 h-auto fc-text4 w-full promotion-content-section" v-html="promotionModel.Content" />
      </div>
      </el-scrollbar>
      <div class="p-5 pt-0 pb-4 mt-2" :class="{ 'text-right': isSBO }">
        <template v-if="promotionModel.PromotionTypeId === 10">
          <el-button
            v-if="validateLuckyWheelbutton(promotionModel)"
            round
            type="primary"
            class="apply promotion-button promotion-btn"
            @click="onClickSpinNow"
            :id = "`mobile_${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotionModel.PromotionTypeId]}_${promotionModel.Id}`"
            >{{ $t("Spin Now") }}</el-button
          >
        </template>
        <template v-else>
          <el-button
            v-if="buttonApplyPromotionEnabled(promotionModel)"
            type="primary promotion-btn"
            round
            :loading="isProcessing"
            @click="onApplyPromotion(promotionModel)"
            :id = "`mobile_${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotionModel.PromotionTypeId]}_${promotionModel.Id}`"
            >{{ $t("apply") }}</el-button
          >
        </template>
      </div>
    </div>
  </el-dialog>
</template>
<script lang="ts">
import { computed, defineComponent } from "vue";
import { store } from "@/store";
import commonHelper from "@/utils/commonHelper";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { ID } from "~~/utils/constants";

export default defineComponent({
  name: "MPromotionComponent",
  setup() {
    const auth = computed(() => store.state.auth);
    const { themeColor } = themePropertyHelper;
    const register = computed(() =>
      themePropertyHelper.getSingleThemeProperty(
        store.state.companyThemePropertiesFromApi.ThemeProperties,
        "register"
      )
    );
    const isSBO = computed(
      (): boolean => store.state.selectedThemeName === "sbo"
    );
    const selectedTheme = computed(() => store.state.selectedThemeName);
    const {
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      assignHashText,
      applyRequest,
      onClickSpinNow,
      validateLuckyWheelbutton,
    } = usePromotion();
    const router = useRouter();
    const onCancel = () => {
      isDialogVisible.value = false;
      router.push('/promotion');
    };
    const { getAssetImage } = commonHelper;
    const toggleAuthModal = (): void => {
      store.commit("updateLoginDialog", true);
    };
    const route = useRoute();
    watch(() => [route.params, promotions.value], () => {
      const found = promotions.value.find((item) => item.Id === Number(route.params.id));
      if (found) onMoreInformation(found);
    }, {deep: true, immediate: true});
    return {
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      onCancel,
      auth,
      getAssetImage,
      register,
      toggleAuthModal,
      isSBO,
      assignHashText,
      selectedTheme,
      themeColor,
      applyRequest,
      onClickSpinNow,
      validateLuckyWheelbutton,
    };
  },
});
</script>
<style lang="scss" scoped>
:deep(button.el-button) {
  width: 100% !important;
  height: 40px;
}
:deep(.el-button span) {
  @apply text-sm font-bold leading-4;
}
:deep(.el-button.is-absolute span) {
  @apply absolute whitespace-normal;
}
.promotion-img {
  object-fit: contain;
}
[layout="main"] .promotion-img {
  object-fit: cover;
}
.promo-card-border {
  border-radius: 8px;
}
[layout="main"] .promo-card-border {
  border: none;
}
.apply.promotion-button.is-disabled {
  opacity: 1 !important;
}
</style>
<style lang="scss">
[layout="playful"][data-device="mobile"] {
  .playful-promotion-header {
    display: none;
  }
  .playfull-promotion-container {
      padding-bottom: 4rem;
    .promo-card-border, .promotion-img, .promotion-content, .information-info {
      width: 100%;
    }
    .playful-promotion-bar {
      margin-top: 0px !important;
      margin-bottom: 8px !important;
    }
  }
}
.el-promo-dialog {
  @apply overflow-hidden;
  --el-dialog-bg-color: var(--background5) !important;
  --el-dialog-width: 94% !important;
  --el-dialog-padding-primary: none !important;
  --el-dialog-border-radius: 0.5rem !important;
  --el-dialog-margin-top: 16px !important;
  border-radius: 8px;
  // height: auto;
  // max-height: calc(100vh - 19%);

  .el-scrollbar {
    .el-scrollbar__wrap {
      // max-height: 382px;
      font-size: 12px;
    }
  }
}
.el-promo-dialog .el-dialog__header {
  margin-right: 0 !important;
  padding-bottom: 0 !important;
}
.promo-header-dialog {
  @apply flex flex-row justify-between px-4 items-start break-normal;
  padding-top: 10px;
  padding-bottom: 10px;
  border-bottom: 2px solid var(--border);
  background: var(--background5);
}
[theme-color="bk8"] .close-btn {
  filter: brightness(0);
}
.promotion-content-section {
  table {
    width: 100% !important;
  }
  word-break: break-word;
}
.promotion-btn span {
  pointer-events: none;
}
</style>
